/**
    some "lowlevel" routines
    */

#include "global.h"
#include "xtypewatch.h"
#include "record.h"
#include <stream.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>

void
XTypeWatch::forcePause(const Break *b)
{
    int ms=b->duration_;
    Display *d =display_;

    XBell(d,100);
    int rev;
    Window oldfoc;
    XGetInputFocus(d,&oldfoc, &rev);

    XGrabServer(d);
    // make sure typing has no effect.
    XSetInputFocus(d,window_, RevertToNone,CurrentTime);
    XFlush(d);
    usleep(ms *1000);

    //discard keyevents.
    XEvent xev;
    while (XCheckMaskEvent(d, KeyReleaseMask|KeyPressMask, &xev))
	;
    XSetInputFocus(d, oldfoc, rev, CurrentTime);
    XUngrabServer(d);
    recorder_->resetBreak(b);	
}



void
XTypeWatch::warn() const
{
    XBell(display_, 25);
}



